import csv
import hashlib

import sys
import os
modules_paths = ['.', '../../../modules/']
for modules_path in modules_paths:
    if os.path.exists(modules_path):
        sys.path.insert(1, modules_path)

from messaging.MessageHandler import MessageHandler
from db.repository import Repository

# file to read the data from
CSV_FILE = r'dummy_upload/community-prediction-youtube/videos.csv'
handler = MessageHandler(Repository())


import csv
import json
from datetime import datetime
from typing import Iterator
import pandas as pd
from pandas import DataFrame


def load_csv_content() -> Iterator:
    '''Returns a generator for all lines in the csv file with correct field types.'''
    dfs: DataFrame = pd.read_csv(CSV_FILE)
    return dfs.iterrows()

def upload_transaction(transaction):
    # manually flatten based on table mapping
    uid = transaction['video_id']

    transaction['UniqueID'] = uid
    transaction['trend_delay'] = transaction['trend_duration']
    transaction['timestamp'] = transaction['trending_timestamp']

    del transaction['trend_duration']
    del transaction['trending_timestamp']

    t = {        
        'use_case':  'community-prediction-youtube',
        'table':  'community-prediction-youtube',
        'id': uid,
        'properties': transaction,
    }
    handler.handle_new_trace(t)


if __name__ == '__main__':    
    entries = load_csv_content()

    for idx, transaction in entries:
        transaction = transaction.to_dict()
        upload_transaction(transaction)

        if idx % 1000 == 0:
            print(f"Progress: {str(float(idx) / 375942)} %")

    res = handler.get_all()
    with open("res.json", 'w') as f:
        f.write((json.dumps(res)))